#include <bcm2835.h>
#include <stdio.h>
#include "ssd1305.h"
#include <stdlib.h>
#include <string.h>
#include <curl/curl.h>
#include <curl/easy.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <unistd.h>
#include <arpa/inet.h>

 

char value[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};

struct MemoryStruct {
  char *memory;
  size_t size;
};
 
static size_t
WriteMemoryCallback(void *contents, size_t size, size_t nmemb, void *userp)
{
  size_t realsize = size * nmemb;
  struct MemoryStruct *mem = (struct MemoryStruct *)userp;
 
  char *ptr = realloc(mem->memory, mem->size + realsize + 1);
  if(!ptr) {
    /* out of memory! */
    printf("not enough memory (realloc returned NULL)\n");
    return 0;
  }
 
  mem->memory = ptr;
  memcpy(&(mem->memory[mem->size]), contents, realsize);
  mem->size += realsize;
  mem->memory[mem->size] = 0;
 
  return realsize;
}


// -------------- MAIN -------------------

int main(int argc, char **argv)
{
char a_status[20]="";
char a_artist[106]=""; char a_artist0[206]="";
char a_title[106]=""; char a_title0[206]="";
char a_seek[20]="";
char a_duration[20]="";
char a_volume[20]="";
char a_mute[20]="";
char a_tracktype[20]="";
char a_samplerate[20]="";
char a_bitdepth[20]="";
char a_bitrate[20]="";
char a_random[20]="";
char a_repeat[20]="";
char a_repeats[20]="";
char a_position[20]=""; int pocou=0; int pocou2 = 1; int pocou3 = 1;
int tdcou = 30; int tdcou2 = 0; // int tdcou3 = 0;
int nxcou = 0; int nxcou2 = 1; int nxcou3 = 0;
int jj = 1; int jj2 = 1;
int jjlap = 1; int jjlap2 = 1;

int n;
char array[] = "wlan0";
char array2[] = "eth0";
char wip[20] ="";
char eip[20] ="";
char ipkirak[20]="";
struct ifreq ifr;
struct ifreq ifr2;



    if(!bcm2835_init())
    {
        return -1;
    }
    printf("OLED for Volumio ver 1.26 beta. Press Ctrl + C to exit.\n");

// IP cim

    n = socket(AF_INET, SOCK_DGRAM, 0);
    //Type of address to retrieve - IPv4 IP address
    ifr.ifr_addr.sa_family = AF_INET;
    ifr2.ifr_addr.sa_family = AF_INET;
    //Copy the interface name in the ifreq structure
    strncpy(ifr.ifr_name , array , IFNAMSIZ - 1);
    ioctl(n, SIOCGIFADDR, &ifr);
    strncpy(ifr2.ifr_name , array2 , IFNAMSIZ - 1);
    ioctl(n, SIOCGIFADDR, &ifr2);
    close(n);
    sprintf(wip, "%s" , inet_ntoa(( (struct sockaddr_in *)&ifr.ifr_addr )->sin_addr) );
    sprintf(eip, "%s" , inet_ntoa(( (struct sockaddr_in *)&ifr2.ifr_addr )->sin_addr) );
    if ( strncmp(eip, "192.168.", 8)==0 ) strcpy(ipkirak,eip);
    else if ( strncmp(wip, "192.168.", 8)==0 ) strcpy(ipkirak,wip);

//printf("IP: %s\n", ipkirak);


// curl ----------------------------

  CURL *curl_handle;
  CURLcode res;
  struct MemoryStruct chunk;

// oled --------- INTRO ----------

    SSD1305_begin();

    SSD1305_bitmap(0, 14, logo_volumio,128,32); // logo
    SSD1305_string(20,0,"OLED V1.26B FOR", 12,1,1);
//    SSD1305_string(12,8,"V O L U M I O", 16,1,0);
    SSD1305_display();
    bcm2835_delay(3000);
    SSD1305_clear();

    SSD1305_bitmap(0, 14, logo_volumio,128,32); // logo
    if ( strlen(ipkirak)>0 )
     	{
	char ipkirak2[25]="IP: ";
        int eltcen_ipk = 0;
	strcat(ipkirak2,ipkirak);
	eltcen_ipk=(128-(strlen(ipkirak2)*6))/2;
	SSD1305_string(0+eltcen_ipk,0,ipkirak2, 12,1,1);
	}
	else SSD1305_string(20,0,"OLED V1.26B FOR", 12,1,1);
    SSD1305_display();
    bcm2835_delay(14000);
    SSD1305_clear();

    while(1)
    {

// CURL --------------------

  chunk.memory = malloc(1);  /* will be grown as needed by the realloc above */
  chunk.size = 0;    /* no data at this point */
 
  curl_global_init(CURL_GLOBAL_ALL);
  curl_handle = curl_easy_init();
  curl_easy_setopt(curl_handle, CURLOPT_URL, "http://127.0.0.1:3000/api/v1/getState");
  curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, WriteMemoryCallback);
  curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)&chunk);
  res = curl_easy_perform(curl_handle);
 
  if(res != CURLE_OK) {
    fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
    SSD1305_string(0,12,"CURL ERROR: no MPD service?", 12,0,0);
    SSD1305_display();
    bcm2835_delay(5000);
    SSD1305_clear();
    SSD1305_display();
  }
  else {
//    printf("%lu bytes retrieved\n", (unsigned long)chunk.size);
//    printf("%s \n",chunk.memory);
//    printf("%d \n",strlen(chunk.memory)); 
  char dest[2]="";
  char ezjs[2]="{";
  strncpy(dest,chunk.memory,1);
  if ( strlen(chunk.memory)<150 || strcmp(dest,ezjs)!=0 ) {
    SSD1305_string(0,12,"CURL ERROR: no json?", 12,0,0);
    SSD1305_display();
    bcm2835_delay(5000);
    SSD1305_clear();
    SSD1305_display();
  }

   char haystack[2048] = "";
   strcpy(haystack, chunk.memory);
   const char vege1[4]="\",\""; // egyel tobb tarolo kell mindig!
   const char vege2[3]=",\"";
   char *ret1;
   char *ret2;

   const char s_status[11] = "\"status\":\"";
   memset(a_status, '\0', sizeof(a_status));
   ret1 = strstr(haystack+0, s_status);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_status),vege1);
   strncpy(a_status, ret1+strlen(s_status), strlen(ret1)-strlen(s_status)-strlen(ret2));
   } else {
   strcpy(a_status, "stop");
   }
   if ( strcmp(a_status, "stop")==0 ) strcat(a_status,"<");
   if ( strcmp(a_status, "play")==0 ) strcat(a_status,">");
   if ( strcmp(a_status, "pause")==0 ) strcat(a_status,"=");
   int i = 0;   while(a_status[i]) { a_status[i]=toupper(a_status[i]); i++; }


   const char s_title[10] = "\"title\":\"";
   memset(a_title, '\0', sizeof(a_title));
   ret1 = strstr(haystack+0, s_title);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_title),vege1);
   strncpy(a_title, ret1+strlen(s_title), strlen(ret1)-strlen(s_title)-strlen(ret2));
   } else {
   const char karnu4[2]=" ";
   strcpy(a_title, karnu4);
   }
// printf("Title cahrs: %d \n",strlen(a_title));
   char icht[6] ="";  char icht2[2] ="";
   int i2 = 0; 
   int voltc = 0;
   char helyett[2]="?";
   memset(a_title0, '\0', sizeof(a_title0));
   while ( a_title[i2] )
	{
	memset(icht, '\0', sizeof(icht));
	sprintf(icht, "%d", a_title[i2]);
        memset(icht2, '\0', sizeof(icht2));
        sprintf(icht2, "%c", a_title[i2]);
	if ( atoi(icht)<128 )
		{
		if ( voltc>0 ) { voltc=0; strncat(a_title0, helyett, 1);  }
		if ( atoi(icht)!=92 ) strncat(a_title0, icht2, 1);
		}
		else voltc++;
	i2++;
	}
//printf("Tit: %s\n", a_title0);
   memset(a_title, '\0', sizeof(a_title)); strcpy(a_title,a_title0);

   const char s_artist[11] = "\"artist\":\"";
   memset(a_artist, '\0', sizeof(a_artist));
   ret1 = strstr(haystack+0, s_artist);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_artist),vege1);
   strncpy(a_artist, ret1+strlen(s_artist), strlen(ret1)-strlen(s_artist)-strlen(ret2));
   } else {
   const char karnu3[2]=" ";
   strcpy(a_artist, karnu3);
   }
   char icha[6] ="";  char icha2[2] ="";
   int i2a = 0; 
   int voltca = 0;
   memset(a_artist0, '\0', sizeof(a_artist0));
   while ( a_artist[i2a] )
	{
	memset(icha, '\0', sizeof(icha));
	sprintf(icha, "%d", a_artist[i2a]);
        memset(icha2, '\0', sizeof(icha2));
        sprintf(icha2, "%c", a_artist[i2a]);
	if ( atoi(icha)<128 )
		{
		if ( voltca>0 ) { voltca=0; strncat(a_artist0, helyett, 1);  }
		if ( atoi(icha)!=92 ) strncat(a_artist0, icha2, 1);
		}
		else voltca++;
	i2a++;
	}
   memset(a_artist, '\0', sizeof(a_artist)); strcpy(a_artist,a_artist0); 

   const char s_seek[8] = "\"seek\":";
   memset(a_seek, '\0', sizeof(a_seek));
   ret1 = strstr(haystack+0, s_seek);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_seek),vege2);
   strncpy(a_seek, ret1+strlen(s_seek), strlen(ret1)-strlen(s_seek)-strlen(ret2));
   } else {
   const char karnu2[2]="0";
   strcpy(a_seek, karnu2);
   }

   const char s_duration[12] = "\"duration\":";
   memset(a_duration, '\0', sizeof(a_duration));
   ret1 = strstr(haystack+0, s_duration);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_duration),vege2);
   strncpy(a_duration, ret1+strlen(s_duration), strlen(ret1)-strlen(s_duration)-strlen(ret2));
   } else {
   const char karnu[2]="0";
   strcpy(a_duration, karnu);
   }

   const char s_position[12] = "\"position\":";
   memset(a_position, '\0', sizeof(a_position));
   ret1 = strstr(haystack+0, s_position);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_position),vege2);
   strncpy(a_position, ret1+strlen(s_position), strlen(ret1)-strlen(s_position)-strlen(ret2));
   } else {
   strcpy(a_position, "0");
   }

   const char s_mute[8] = "\"mute\":";
   memset(a_mute, '\0', sizeof(a_mute));
   ret1 = strstr(haystack+0, s_mute);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_mute),vege2);
   strncpy(a_mute, ret1+strlen(s_mute), strlen(ret1)-strlen(s_mute)-strlen(ret2));
   } else {
   const char karnu5[6]="false";
   strcpy(a_mute, karnu5);
   }

   const char s_random[10] = "\"random\":";
   memset(a_random, '\0', sizeof(a_random));
   ret1 = strstr(haystack+0, s_random);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_random),vege2);
   strncpy(a_random, ret1+strlen(s_random), strlen(ret1)-strlen(s_random)-strlen(ret2));
   } else {
   strcpy(a_random, "false");
   }

   const char s_repeat[10] = "\"repeat\":";
   memset(a_repeat, '\0', sizeof(a_repeat));
   ret1 = strstr(haystack+0, s_repeat);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_repeat),vege2);
   strncpy(a_repeat, ret1+strlen(s_repeat), strlen(ret1)-strlen(s_repeat)-strlen(ret2));
   } else {
   strcpy(a_repeat, "false");
   }

   const char s_repeats[16] = "\"repeatSingle\":";
   memset(a_repeats, '\0', sizeof(a_repeats));
   ret1 = strstr(haystack+0, s_repeats);
   if ( ret1 ) { // neha hianyzik!
   ret2 = strstr(ret1+strlen(s_repeats),vege2);
   strncpy(a_repeats, ret1+strlen(s_repeats), strlen(ret1)-strlen(s_repeats)-strlen(ret2));
   } else {
   strcpy(a_repeats, "false");
   }

   const char s_volume[10] = "\"volume\":";
   memset(a_volume, '\0', sizeof(a_volume));
   ret1 = strstr(haystack+0, s_volume);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_volume),vege2);
   strncpy(a_volume, ret1+strlen(s_volume), strlen(ret1)-strlen(s_volume)-strlen(ret2));
   const char idezos[3] = "\"\"";
   if ( strlen(a_volume)<1 ) strcpy(a_volume,"0");
   else if ( strcmp(a_volume, idezos)==0 ) strcpy(a_volume,"0");
   } else {
   strcpy(a_volume,"0");
   }
// printf("Sta: %s\n", a_status); printf("Tit: %s\n", a_title); printf("Art: %s\n", a_artist); printf("See: %s\n", a_seek); printf("Dur: %s\n", a_duration); printf("Vol: %s\n", a_volume);

   const char s_tracktype[14] = "\"trackType\":\"";
   memset(a_tracktype, '\0', sizeof(a_tracktype));
   ret1 = strstr(haystack+0, s_tracktype);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_tracktype),vege1);
   strncpy(a_tracktype, ret1+strlen(s_tracktype), strlen(ret1)-strlen(s_tracktype)-strlen(ret2));
   } else strcpy(a_tracktype, "track");

   const char s_samplerate[15] = "\"samplerate\":\"";
   memset(a_samplerate, '\0', sizeof(a_samplerate));
   ret1 = strstr(haystack+0, s_samplerate);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_samplerate),vege1);
   strncpy(a_samplerate, ret1+strlen(s_samplerate), strlen(ret1)-strlen(s_samplerate)-strlen(ret2));
   } else strcpy(a_samplerate, "");

   const char s_bitdepth[13] = "\"bitdepth\":\"";
   memset(a_bitdepth, '\0', sizeof(a_bitdepth));
   ret1 = strstr(haystack+0, s_bitdepth);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_bitdepth),vege1);
   strncpy(a_bitdepth, ret1+strlen(s_bitdepth), strlen(ret1)-strlen(s_bitdepth)-strlen(ret2));
   } else strcpy(a_bitdepth, "");

   const char s_bitrate[12] = "\"bitrate\":\"";
   memset(a_bitrate, '\0', sizeof(a_bitrate));
   ret1 = strstr(haystack+0, s_bitrate);
   if ( ret1 ) {
   ret2 = strstr(ret1+strlen(s_bitrate),vege1);
   strncpy(a_bitrate, ret1+strlen(s_bitrate), strlen(ret1)-strlen(s_bitrate)-strlen(ret2));
   } else strcpy(a_bitrate, "");



  }
 
  curl_easy_cleanup(curl_handle);
  free(chunk.memory);
  curl_global_cleanup();



// OLED KIJELZO ----------------
// 21 karakter max  6x21=126 pixel
// elso sorba:
// status:
        SSD1305_string(0,0, a_status, 12, 1, 1);
// position:
	int posi1=0; int pduratime=0;
	char posi2[3]="";
	char ki_position[5]="";
	const char mutetrue2[5] = "true";
	if ( strcmp(a_random, mutetrue2)==0 ) strcat(ki_position,"_`");
	else if ( strcmp(a_repeats, mutetrue2)==0 ) strcat(ki_position,"\\`");
	else if ( strcmp(a_repeat, mutetrue2)==0 ) strcat(ki_position,"^`");
	else strcat(ki_position," `");
	posi1=atoi(a_position)+1;
	if ( posi1>=100 ) posi1=99;
	sprintf(posi2, "%d", posi1);
	if ( strlen(posi2)==1 ) strcat(ki_position,"0");
	strcat(ki_position,posi2);
	pduratime=atoi(a_duration);
	if ( pocou3!=pduratime )
		{
		pocou3=pduratime;
		pocou2=1;
		pocou=0;
		}
	if ( pocou>=6000 ) pocou2=0; // 6 sec-ig posinfo

// volume or posinfo:
	int hos=0;
	if ( strlen(a_volume)==3 ) hos=2;
        if ( strlen(a_volume)==2 ) hos=7;
	if ( strlen(a_volume)==1 ) hos=12;
	const char mutetrue[5] = "true";
	if ( pocou2>0 )
	{
	SSD1305_string(108,0, ki_position, 11, 1,0);
	}
	else
	{
	if ( strcmp(a_mute, mutetrue)==0 ) SSD1305_string(108,0, "MUTE", 11, 1,0);
	   else SSD1305_string(111+hos,0, a_volume, 11, 1,0);
	}
// time:
	char prenu[2]="0"; char prekp[2]=":"; char prepr[2]="/";
	char nutemp[10]="";
	char ki_time[12]="";
	int perc1=0; int perc2=0; int seekt=0;
	int maso1=0; int maso2=0;
	perc1=atoi(a_duration)/60;
	maso1=atoi(a_duration)%60;
	if ( perc1>=100 ) { perc1=99; maso1=59; }
	seekt=atoi(a_seek)/1000;
	perc2=seekt/60;
	maso2=seekt%60;
	if ( perc2>=100 ) { perc2=99; maso2=59; }
//printf("P: %d\nM: %d\n",perc1,maso1);	
	char ki_time1p[3]="";
	char ki_time1m[3]="";
	char ki_time2p[3]="";
	char ki_time2m[3]="";
	sprintf(ki_time1p, "%d", perc1);
	sprintf(ki_time1m, "%d", maso1);
	sprintf(ki_time2p, "%d", perc2);
	sprintf(ki_time2m, "%d", maso2);
//printf("%s:%s\n",ki_time1p,ki_time1m);
	if ( strlen(ki_time1p)==1 ) { strcpy(nutemp,prenu); strcat(nutemp,ki_time1p); strcpy(ki_time1p,nutemp); }
	if ( strlen(ki_time1m)==1 ) { strcpy(nutemp,prenu); strcat(nutemp,ki_time1m); strcpy(ki_time1m,nutemp); }
	if ( strlen(ki_time2p)==1 ) { strcpy(nutemp,prenu); strcat(nutemp,ki_time2p); strcpy(ki_time2p,nutemp); }
	if ( strlen(ki_time2m)==1 ) { strcpy(nutemp,prenu); strcat(nutemp,ki_time2m); strcpy(ki_time2m,nutemp); }
// printf("%s:%s\n",ki_time1p,ki_time1m);
	strcat(ki_time,ki_time1p);
	strcat(ki_time,prekp);
	strcat(ki_time,ki_time1m);
	strcat(ki_time,prepr);
	strcat(ki_time,ki_time2p);
	strcat(ki_time,prekp);
	strcat(ki_time,ki_time2m);
	SSD1305_string(43,0, ki_time, 11, 1, 0);

// track adatok:
	int seektime=0; int duratime=0;
	char ki_trackdata[22]="";
	seektime=atoi(a_seek);
	duratime=atoi(a_duration);
	strcat(ki_trackdata,a_tracktype);
	if ( strlen(a_samplerate)>0 ) { strcat(ki_trackdata," "); strcat(ki_trackdata,a_samplerate); }
	if ( strlen(a_bitdepth)>0 ) { strcat(ki_trackdata," "); strcat(ki_trackdata,a_bitdepth); }
	if ( strlen(a_bitrate)>0 ) { strcat(ki_trackdata," "); strcat(ki_trackdata,a_bitrate); }
//	if ( tdcou3!=duratime ) tdcou2=0;
// next eseten tiltas
	if ( nxcou>=30 ) nxcou2=1;
	if ( nxcou3!=duratime )
		{
		nxcou3=duratime;
		if ( nxcou<30 ) nxcou2=0;
		nxcou=0;
		}

// masodik harmadik sorba:
	jjlap=strlen(a_artist)/21;
	if ( strlen(a_artist)%21>0 ) jjlap++;
	if ( jj>jjlap  ) jj=1;
	jjlap2=strlen(a_title)/21;
	if ( strlen(a_title)%21>0 ) jjlap2++;
	if ( jj2>jjlap2 ) jj2=1;

	char ki_artist[22]="";
	char ki_title[22]="";
	int elt_artist = 0;
	int elt_title = 0;
	elt_artist=21*(jj-1);
	elt_title=21*(jj2-1);
	strncpy(ki_artist, a_artist+elt_artist, 21);
	strncpy(ki_title, a_title+elt_title, 21);
// printf("%s\n%s\n",a_title,ki_title);
// printf("pos1: %d\njj lap1: %d\n",jj,jjlap); printf("pos2: %d\njj lap2: %d\n",jj2,jjlap2);

	if ( ((tdcou>=30 && seektime<=6500) || tdcou2>0 ) && nxcou2>0 && seektime>=4500 && strcmp(ki_trackdata,"track")!=0 && strcmp(a_status,"STOP<")!=0 ) // ez elso par secben track data
	{ // trackdata
	int eltcen_trackdata = 0; 
	int i5 = 0; while(ki_trackdata[i5]) { ki_trackdata[i5]=toupper(ki_trackdata[i5]); i5++; }
	eltcen_trackdata=(128-(strlen(ki_trackdata)*6))/2;
	SSD1305_string(0+eltcen_trackdata,20, ki_trackdata, 12, 0, 0);
	if ( tdcou2<1 ) { tdcou=0; tdcou2=1; } // tdcou3=duratime;
	}
	else
	{ // title
	int eltcen_title = 0;
	SSD1305_pixel(126,28,1); SSD1305_pixel(126,26,1); SSD1305_pixel(127,27,1); 
	if ( jjlap2<2 ) {
		eltcen_title=(128-(strlen(a_title)*6))/2; 
			SSD1305_pixel(126,28,0); SSD1305_pixel(126,26,0); SSD1305_pixel(127,27,0);		
		}
	SSD1305_string(0+eltcen_title,20, ki_title, 12, 1, 0); 
	}

	// artist
	int eltcen_artist = 0;
	SSD1305_pixel(126,16,1); SSD1305_pixel(126,14,1); SSD1305_pixel(127,15,1); 
	if ( jjlap<2 ) {
		eltcen_artist=(128-(strlen(a_artist)*6))/2; 
        	SSD1305_pixel(126,16,0); SSD1305_pixel(126,14,0); SSD1305_pixel(127,15,0);
		}
	SSD1305_string(0+eltcen_artist, 8, ki_artist, 12, 1, 0); // kitakaras miatt ez a masodik!


	// idocsik
	int ics, ics2, csszazi;
	int cssec=0;
	double csszaz=0, seektd=0, cssecd=0;
//	for (ics = 0; ics <= 54; ics++) SSD1305_pixel(44+ics,6,0); // 55 a hossz
        for (ics = 0; ics <= 127; ics++) SSD1305_pixel(0+ics,6,0); // 128 a hossz

        cssec=atoi(a_duration);
	cssecd=atof(a_duration);
	seektd=atof(a_seek)/1000;
	if ( cssec>0 && seekt>0 )
	{
//	csszaz=((seektd/cssecd)*100.00)*(55.00/100.00); // 55 a hossz
        csszaz=((seektd/cssecd)*100.00)*(128.00/100.00); // 128 a hossz
	csszazi=(int)csszaz;
//	for (ics2 = 0; ics2 <= csszazi; ics2++) SSD1305_pixel(44+ics2,6,1);
        for (ics2 = 0; ics2 <= csszazi; ics2++) SSD1305_pixel(0+ics2,6,1);
//printf("szaz: %d %f %f \n",csszazi,seektd,cssecd);
	}



        SSD1305_display();
        bcm2835_delay(1000);


//        bcm2835_delay(5000);
//        SSD1305_clear();
//	SSD1305_display();
//        bcm2835_delay(3000);

	// lap	
	jj++; jj2++;
	if ( jj>jjlap  ) jj=1;
	if ( jj2>jjlap2 ) jj2=1;

	if ( tdcou>=4 ) tdcou2=0; // 4 sec ig trackdata
	tdcou++;
	nxcou++;
	pocou++;
//printf("tdcou: %d dura: %d td3: %d td2: %d \n",tdcou,duratime,tdcou3,tdcou2);
    }


    SSD1305_clear();
    SSD1305_display();
    bcm2835_spi_end();
    bcm2835_close();


    
    return 0;
}

